//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  PaleVioletRed
#property  indicator_color2  PaleVioletRed
#property  indicator_style1  STYLE_DOT
#property  indicator_style2  STYLE_DOT

//
//
//
//
//

extern int    ChannelInitialPeriod   = 150;
extern string ChannelName            = "Channel 1/3";
extern color  ChannelColor           = DeepSkyBlue;
extern double ChannelAdditionLinesAt = 0.33333;
extern bool   UseHighLow             = false;

//
//
//
//
//

double bufferMiu[];
double bufferMid[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferMiu);
   SetIndexBuffer(1,bufferMid);
         IndicatorShortName("regression channel ("+ChannelName+")");
   return(0);
}

//
//
//
//
//

int deinit()
{
   switch(UninitializeReason())
   {
      case REASON_CHARTCHANGE:
      case REASON_PARAMETERS:
      case REASON_RECOMPILE:   break;
      case REASON_CHARTCLOSE:
      case REASON_REMOVE:
      case REASON_ACCOUNT:    ObjectDelete(ChannelName);
   }
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double regressionLine[];
int start()
{
   if (ObjectFind(ChannelName)==-1)
       ObjectCreate(ChannelName,OBJ_REGRESSION,0,Time[ChannelInitialPeriod-1],0,Time[0],0);
          ObjectSet(ChannelName,OBJPROP_COLOR,ChannelColor);

      //
      //
      //
      //
      //
       
         double   priceStart    = ObjectGet(ChannelName,OBJPROP_PRICE1); 
         double   priceEnd      = ObjectGet(ChannelName,OBJPROP_PRICE2);
         int      barStart      = iBarShift(NULL,0,ObjectGet(ChannelName,OBJPROP_TIME1));
         int      barEnd        = iBarShift(NULL,0,ObjectGet(ChannelName,OBJPROP_TIME2));
         int      channelPeriod = barStart-barEnd;
         double   slope         = (priceStart-priceEnd)/channelPeriod;
         double   dist          = 0;

         //
         //
         //
         //
         //
         
         if (ArraySize(regressionLine)!=channelPeriod) ArrayResize(regressionLine,channelPeriod);
         
            for (int k=0; k<channelPeriod; k++)
            {
               regressionLine[k]=priceEnd+k*slope;
                  dist = MathMax(dist,MathMax(Close[barEnd+k]-regressionLine[k],regressionLine[k]-Close[barEnd+k]));
            }
            for (k=0; k<channelPeriod; k++)
            {
               bufferMiu[barEnd+k] = regressionLine[k]+dist*ChannelAdditionLinesAt;
               bufferMid[barEnd+k] = regressionLine[k]-dist*ChannelAdditionLinesAt;
            }
      
   //
   //
   //
   //
   //
 
   int drawBegin = Bars-channelPeriod;
         for (k=0; k<2; k++) SetIndexDrawBegin(k,drawBegin-barEnd);
         for (k=barEnd-1; k>=0; k--)
         {
            bufferMiu[k] = EMPTY_VALUE;
            bufferMid[k] = EMPTY_VALUE;
         }
   return(0);
}

